=== generic/rlsmt/Makefile ===
rlsmt.img: mkrlsmt.red
	redpsl < mkrlsmt.red
