=== debianbuild/reduce/debian/changelog ===
reduce (20120521) unstable; urgency=low

  * New Snapshot.

 -- REDUCE Developers <reduce-algebra-developers@lists.sourceforge.net>  Mon, 21 May 2012 20:57:39 +0100
